
/*  A Bison parser, made from tdl.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	REAL	258
#define	INTEGER	259
#define	QUOTED_STRING	260
#define	HEX_INTEGER	261
#define	BINARY_INTEGER	262
#define	PROPERTYNAME	263
#define	VARIABLE_NAME	264
#define	TEMPLATE	265
#define	COMMENT	266
#define	ABSTRACT	267
#define	VALIDATION_KEYCODE	268
#define	TDL_VERSION_NUMBER	269
#define	SPACING	270
#define	ENDTEMPLATE	271
#define	SELECTCASE	272
#define	ENDSELECT	273
#define	CASE	274
#define	ENDCASE	275
#define	STRUCTARRAY	276
#define	ENDSTRUCTARRAY	277
#define	ID	278
#define	CAL	279
#define	USR	280
#define	ALIGN	281
#define	UGID	282
#define	UNINT	283
#define	CHR5	284
#define	DATE	285
#define	CONRELRES	286
#define	CONRES	287
#define	BITBIN	288
#define	STRING5	289
#define	STRING7	290
#define	STRING16	291
#define	ASCII	292
#define	SINGLE	293
#define	UNICOD	294
#define	END_OF_LINE	295
#define	DEFAULT	296
#define	INITIALIZE	297
#define	READWRITE	298
#define	CTRLFUNCTIONMASK	299
#define	FUNCTIONTYPE	300
#define	FUNCTION	301
#define	ENUMERATE	302
#define	PHYSICAL_UNIT	303

#line 1 "tdl.y"


// -------------------------------------------------------------------
// TDL.y
//
// This file is a standard input to the compiler compiler bison 
// (which is a variant of yacc). It provides a formal grammar for 
// the IEEE 1451.4 Template Description Language (TDL).  To use 
// this file, you must first create the file lexyy.cpp using the 
// file tdl.l (which contains the token definitions).  You then 
// run this file through bison by executing the command line:
//
//		bison -d tdl.y
//
// After executing this command do:
//
//		rename tdl_tab.c tdl_tab.cpp.  
//
// You can then compile the main TDL compiler using a C++ compiler.
//
// Note that the stack generated by bison in tdl_tab.c may not 
// be big enough.  The sympton of this is that the parser will appear to 
// terminate properly but will not have completed parsing the input 
// file. It might be necessary, inside tdl_tab.cpp, to change
//
//	#define YYINITDEPTH 200
//
// to
//
//	#define YYINITDEPTH 500
//
// One aspect of the design of this grammar that could probably be
// done better is the use of end_of_line.  The need to worry about this
// as something other than white space is a consequence of both the
// comment and abstract commands that use end of line as a delimiter.
//
// Updated 10 September 2003
//
// -------------------------------------------------------------------

#include "tdlparser.h"  // Main header file for TDL compiler.

// -------------------------------------------------------------------
// lex and yacc stuff
// -------------------------------------------------------------------

extern int yyerror (char*);
extern int yylex ();

// -------------------------------------------------------------------
// debug variables
// -------------------------------------------------------------------

extern int statement_count;
extern void print_statement_num ();

// -------------------------------------------------------------------
// semantic action routine prototypes
// -------------------------------------------------------------------

extern void initialize_parser ();
extern void finalize_parser ();
extern void initialize_template ();
extern void finalize_template ();
extern void process_abstract_statement();
extern void process_align ();
extern void process_case ();			
extern void process_case_end ();			
extern void process_comment();
extern void process_enumerate ();			
extern void process_end_enumerate ();			
extern void process_enumerate_item ();			
extern void process_physical_unit ();
extern void process_property_definition ();
extern void process_selectcase ();
extern void process_endselect ();
extern void process_spacing ();
extern void process_structarray_statement();
extern void process_endstructarray_statement();
extern void process_subproperty ();
extern void process_template_statement();
extern void process_tdl_version_number ();
extern void process_ugid ();
extern void process_validation_keycode ();


#line 94 "tdl.y"
typedef union {
  double real;
  char* str;
  int integer;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		249
#define	YYFLAG		-32768
#define	YYNTBASE	55

#define YYTRANSLATE(x) ((unsigned)(x) <= 303 ? yytranslate[x] : 138)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    53,
    54,     2,     2,    49,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    52,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    50,     2,    51,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     5,    10,    12,    13,    16,    18,    20,    21,
    26,    27,    39,    41,    43,    45,    46,    48,    49,    53,
    54,    58,    60,    62,    64,    66,    68,    70,    72,    74,
    76,    78,    80,    83,    85,    86,    91,    95,    96,   100,
   102,   104,   106,   111,   126,   127,   131,   132,   133,   139,
   141,   143,   145,   147,   149,   151,   153,   154,   156,   157,
   158,   165,   166,   168,   170,   172,   174,   176,   178,   184,
   190,   192,   194,   196,   198,   200,   202,   204,   206,   207,
   209,   210,   212,   214,   215,   216,   217,   218,   219,   220,
   221,   222,   223,   224,   225,   226,   264,   265,   266,   270,
   272,   274,   276,   278,   280,   281,   292,   293,   296,   297,
   298,   309,   310,   311,   325,   326,   329,   332,   335,   338,
   339,   345,   348,   350,   352,   354,   356,   358,   360,   362,
   364,   366,   369,   372,   375,   378,   380,   381
};

static const short yyrhs[] = {    58,
    56,   137,     0,     0,    57,    60,    58,    56,     0,   123,
     0,     0,    59,    58,     0,    73,     0,   136,     0,     0,
    61,    62,    68,    16,     0,     0,    10,    64,   132,    65,
   132,    66,    49,    67,    63,   136,   137,     0,     4,     0,
     4,     0,     4,     0,     0,   124,     0,     0,    69,   137,
    68,     0,     0,    71,    70,   136,     0,    72,     0,    73,
     0,    74,     0,    79,     0,    80,     0,   109,     0,    15,
     0,   115,     0,   120,     0,   121,     0,    12,     0,    26,
   128,     0,    11,     0,     0,    47,     9,    75,    76,     0,
   132,    78,    77,     0,     0,   132,    78,    77,     0,     5,
     0,     9,     0,   131,     0,    48,     5,   132,    93,     0,
    81,   132,    86,   132,    89,   132,   127,   132,    90,   132,
    91,    49,    92,   106,     0,     0,     8,    82,    83,     0,
     0,     0,    50,    85,    51,    84,   137,     0,    41,     0,
    42,     0,    43,     0,    44,     0,     5,     0,    45,     0,
    46,     0,     0,   124,     0,     0,     0,     8,    87,    50,
     5,    88,    51,     0,     0,    23,     0,    24,     0,    25,
     0,    28,     0,    29,     0,    30,     0,    31,   132,   129,
   132,   130,     0,    32,   132,   129,   132,   130,     0,    37,
     0,    34,     0,    35,     0,    36,     0,    38,     0,    39,
     0,    33,     0,     9,     0,     0,     5,     0,     0,     5,
     0,    93,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   134,   131,    94,   132,   131,
    95,   132,   131,    96,   132,   131,    97,   132,   131,    98,
   132,   131,    99,   132,   131,   100,   132,   131,   101,   132,
   131,   102,   132,   131,   103,   132,   131,   104,   132,   131,
   105,   135,     0,     0,     0,   133,   107,   108,     0,     6,
     0,     7,     0,     9,     0,   131,     0,     5,     0,     0,
    17,   124,   132,    89,   132,   126,   110,   137,   111,    18,
     0,     0,   112,   111,     0,     0,     0,    19,   124,   132,
   125,   113,   137,    68,    20,   114,   137,     0,     0,     0,
    21,     9,   116,   132,   124,   132,    89,   132,   127,   117,
   137,   118,    22,     0,     0,   119,   118,     0,    80,   137,
     0,   115,   137,     0,    14,     4,     0,     0,    27,     5,
   122,   132,   124,     0,    13,     4,     0,     5,     0,     4,
     0,     4,     0,     4,     0,     4,     0,   131,     0,   131,
     0,     3,     0,     4,     0,    49,   137,     0,    52,   137,
     0,    53,   137,     0,   137,    54,     0,    40,     0,     0,
   136,   137,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   130,   132,   133,   135,   137,   137,   138,   138,   140,   140,
   142,   145,   147,   148,   149,   150,   150,   152,   152,   153,
   154,   154,   155,   156,   157,   158,   160,   161,   162,   163,
   165,   167,   168,   169,   171,   173,   174,   176,   176,   177,
   179,   181,   184,   187,   191,   191,   193,   194,   196,   196,
   197,   198,   199,   200,   201,   202,   204,   207,   209,   210,
   212,   212,   213,   214,   215,   217,   218,   219,   220,   222,
   224,   225,   226,   227,   228,   229,   230,   231,   234,   234,
   236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
   246,   247,   248,   249,   250,   253,   253,   254,   258,   258,
   259,   260,   261,   262,   264,   267,   269,   269,   270,   271,
   274,   274,   275,   277,   279,   279,   280,   282,   284,   286,
   287,   289,   292,   294,   295,   297,   298,   300,   301,   303,
   303,   305,   306,   307,   308,   310,   311,   311
};

static const char * const yytname[] = {   "$","error","$illegal.","REAL","INTEGER",
"QUOTED_STRING","HEX_INTEGER","BINARY_INTEGER","PROPERTYNAME","VARIABLE_NAME",
"TEMPLATE","COMMENT","ABSTRACT","VALIDATION_KEYCODE","TDL_VERSION_NUMBER","SPACING",
"ENDTEMPLATE","SELECTCASE","ENDSELECT","CASE","ENDCASE","STRUCTARRAY","ENDSTRUCTARRAY",
"ID","CAL","USR","ALIGN","UGID","UNINT","CHR5","DATE","CONRELRES","CONRES","BITBIN",
"STRING5","STRING7","STRING16","ASCII","SINGLE","UNICOD","END_OF_LINE","DEFAULT",
"INITIALIZE","READWRITE","CTRLFUNCTIONMASK","FUNCTIONTYPE","FUNCTION","ENUMERATE",
"PHYSICAL_UNIT","','","'['","']'","'='","'('","')'","file","template_list","@1",
"between_templates_list","between_templates","template","@2","template_statement",
"@3","manufacturer_code","id_number_of_bits","template_id","optional_description",
"statement_list","statement","@4","abstract_statement","align_statement","comment_statement",
"enumerate_statement","@5","enumerate_list","optional_enumerate_item","enumerate_item",
"physical_unit_statement","property_definition_command","property","@6","optional_subproperty",
"@7","subproperty","optional_prop_description","@8","@9","accesslevel","datatype",
"format","physical_unit","dot2_unit","@10","@11","@12","@13","@14","@15","@16",
"@17","@18","@19","@20","@21","optional_assignment","@22","assignment","selectcase_statement",
"@23","case_statement_list","case_statement","@24","@25","structarray_statement",
"@26","@27","struct_block","struct_block_statement","TDL_VERSION_NUMBER_statement",
"UGID_statement","@28","VALIDATION_KEYCODE_statement","description","case_bit_value",
"selectcase_number_of_bits","size","boundary","startvalue","tolerance","numeric",
"comma","equals","left_paren","right_paren","eol","optional_eol",""
};
#endif

static const short yyr1[] = {     0,
    55,    57,    56,    56,    58,    58,    59,    59,    61,    60,
    63,    62,    64,    65,    66,    67,    67,    68,    68,    70,
    69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
    69,    71,    72,    73,    75,    74,    76,    77,    77,    78,
    78,    78,    79,    80,    82,    81,    83,    84,    83,    85,
    85,    85,    85,    85,    85,    85,    86,    86,    87,    88,
    86,    89,    89,    89,    89,    90,    90,    90,    90,    90,
    90,    90,    90,    90,    90,    90,    90,    90,    91,    91,
    92,    92,    92,    94,    95,    96,    97,    98,    99,   100,
   101,   102,   103,   104,   105,    93,   106,   107,   106,   108,
   108,   108,   108,   108,   110,   109,   111,   111,   113,   114,
   112,   116,   117,   115,   118,   118,   119,   119,   120,   122,
   121,   123,   124,   125,   126,   127,   128,   129,   130,   131,
   131,   132,   133,   134,   135,   136,   137,   137
};

static const short yyr2[] = {     0,
     3,     0,     4,     1,     0,     2,     1,     1,     0,     4,
     0,    11,     1,     1,     1,     0,     1,     0,     3,     0,
     3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     2,     1,     0,     4,     3,     0,     3,     1,
     1,     1,     4,    14,     0,     3,     0,     0,     5,     1,
     1,     1,     1,     1,     1,     1,     0,     1,     0,     0,
     6,     0,     1,     1,     1,     1,     1,     1,     5,     5,
     1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
     0,     1,     1,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    37,     0,     0,     3,     1,
     1,     1,     1,     1,     0,    10,     0,     2,     0,     0,
    10,     0,     0,    13,     0,     2,     2,     2,     2,     0,
     5,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     2,     2,     2,     2,     1,     0,     2
};

static const short yydefact[] = {     5,
    34,   136,     2,     5,     7,     8,     0,   137,     9,     4,
     6,   122,   137,     1,     5,     0,   138,     2,     0,    18,
     3,    13,     0,    45,    32,     0,    28,     0,     0,     0,
     0,     0,     0,     0,   137,    20,    22,    23,    24,    25,
    26,     0,    27,    29,    30,    31,   137,     0,    47,   119,
   123,     0,   112,   127,    33,   120,    35,     0,    10,    18,
     0,    57,   132,    14,     0,     0,    46,    62,     0,     0,
     0,     0,    19,    21,    59,     0,    58,     0,    54,    50,
    51,    52,    53,    55,    56,     0,    63,    64,    65,     0,
     0,     0,    36,     0,   137,    43,     0,     0,    62,    15,
     0,    48,     0,     0,   121,   130,   131,    40,    41,    38,
    42,   134,    84,     0,     0,    16,   137,   125,   105,    62,
    37,     0,     0,    60,     0,    11,    17,    49,   137,     0,
    38,     0,     0,   126,     0,     0,   107,     0,    39,    85,
    61,     0,   137,     0,     0,   107,   113,     0,    78,    66,
    67,    68,     0,     0,    77,    72,    73,    74,    71,    75,
    76,     0,    12,     0,   106,   108,   137,     0,     0,     0,
    79,     0,   115,    86,     0,   128,     0,    80,     0,   124,
   109,   137,   137,     0,   115,     0,     0,     0,    81,   137,
   117,   118,   114,   116,     0,    69,   129,    70,    82,    97,
    83,    18,    87,   137,    44,    98,     0,     0,   133,     0,
   110,     0,   104,   100,   101,   102,    99,   103,   137,    88,
   111,     0,     0,    89,     0,     0,    90,     0,     0,    91,
     0,     0,    92,     0,     0,    93,     0,     0,    94,     0,
     0,    95,   137,    96,     0,   135,     0,     0,     0
};

static const short yydefgoto[] = {   247,
     8,     9,     3,     4,    15,    16,    20,   136,    23,    65,
   101,   126,    34,    35,    61,    36,    37,     5,    39,    71,
    93,   121,   110,    40,    41,    42,    49,    67,   117,    86,
    76,    98,   133,    90,   162,   179,   200,    96,   123,   148,
   186,   208,   222,   225,   228,   231,   234,   237,   240,   243,
   205,   210,   217,    43,   129,   145,   146,   190,   219,    44,
    69,   167,   184,   185,    45,    46,    70,    10,    52,   181,
   119,   135,    55,   175,   196,   111,   122,   206,    97,   244,
    13,    14
};

static const short yypact[] = {     0,
-32768,-32768,     2,     0,-32768,-32768,    20,   -12,-32768,-32768,
-32768,-32768,   -12,-32768,     0,    19,-32768,     2,    28,    84,
-32768,-32768,   -16,-32768,-32768,    35,-32768,    25,    29,    38,
    39,    36,    46,    47,   -12,-32768,-32768,-32768,-32768,-32768,
-32768,   -16,-32768,-32768,-32768,-32768,   -12,    58,    15,-32768,
-32768,   -16,-32768,-32768,-32768,-32768,-32768,   -16,-32768,    84,
   -12,     8,-32768,-32768,   -16,    26,-32768,    34,   -16,   -16,
   -16,    11,-32768,-32768,-32768,   -16,-32768,    69,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    23,-32768,-32768,-32768,   -16,
    25,    25,-32768,    44,   -12,-32768,    14,    27,    34,-32768,
    30,-32768,    72,   -16,-32768,-32768,-32768,-32768,-32768,   -16,
-32768,-32768,-32768,    73,   -16,    25,   -12,-32768,-32768,    34,
-32768,    44,   -16,-32768,    76,-32768,-32768,-32768,   -12,   -16,
   -16,    14,    32,-32768,   -16,   -12,    65,    76,-32768,-32768,
-32768,   203,   -12,    25,    67,    65,-32768,   -16,-32768,-32768,
-32768,-32768,   -16,   -16,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -16,-32768,   -16,-32768,-32768,   -12,    14,    14,    14,
    81,    83,     4,-32768,   -16,-32768,   -16,-32768,    41,-32768,
-32768,   -12,   -12,    71,     4,   -16,    14,    14,    -1,   -12,
-32768,-32768,-32768,-32768,    14,-32768,-32768,-32768,-32768,    42,
-32768,    84,-32768,   -12,-32768,-32768,    77,   -16,-32768,   118,
-32768,    14,-32768,-32768,-32768,-32768,-32768,-32768,   -12,-32768,
-32768,   -16,    14,-32768,   -16,    14,-32768,   -16,    14,-32768,
   -16,    14,-32768,   -16,    14,-32768,   -16,    14,-32768,   -16,
    14,-32768,   -12,-32768,    37,-32768,   102,   103,-32768
};

static const short yypgoto[] = {-32768,
    88,-32768,     6,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -57,-32768,-32768,-32768,-32768,   -19,-32768,-32768,
-32768,   -24,   -10,-32768,  -166,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -97,-32768,-32768,-32768,   -80,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -33,-32768,-32768,-32768,  -159,
-32768,-32768,   -71,-32768,-32768,-32768,-32768,-32768,   -56,-32768,
-32768,    -9,-32768,   -44,   -60,   -51,   -15,-32768,-32768,-32768,
     5,   -13
};


#define	YYLAST		242


static const short yytable[] = {    17,
    38,   115,    73,   199,     6,    77,   182,    48,     6,    11,
     1,    24,    51,   183,     7,    75,   106,   107,   182,     6,
    18,    60,   130,    12,    29,   183,    62,     2,    19,    51,
    79,    22,    47,    63,   104,   105,    68,    53,    50,     2,
    38,    54,    72,    56,    57,   113,   106,   107,   108,    78,
    58,    95,   109,    91,    92,    94,    87,    88,    89,   127,
    99,    64,    59,    95,    66,    74,    80,    81,    82,    83,
    84,    85,   100,   102,   103,   118,   114,   124,   116,   134,
   140,   112,   141,   144,   165,   178,   180,   164,   120,   189,
   246,    24,   193,   204,     1,    25,   211,    26,    27,   125,
    28,   248,   249,   128,    29,    21,   139,   132,   201,    30,
    31,   131,   166,   194,   138,   137,   174,   176,   176,   142,
   106,   107,   213,   214,   215,   177,   216,   198,   147,   163,
    32,    33,   168,     0,     0,   197,   197,   169,   170,     0,
   143,     0,     0,   203,   207,     0,   171,     0,   172,     0,
     0,     0,     0,   173,     0,     0,     0,     0,   218,   187,
   220,   188,     0,     0,     0,     0,     0,     0,   191,   192,
   195,   224,     0,     0,   227,     0,   202,   230,     0,     0,
   233,     0,    38,   236,     0,     0,   239,     0,     0,   242,
   209,     0,   212,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   221,   223,     0,     0,   226,
     0,   149,   229,     0,     0,   232,     0,     0,   235,     0,
     0,   238,     0,     0,   241,     0,     0,     0,     0,   245,
   150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
   160,   161
};

static const short yycheck[] = {    13,
    20,    99,    60,     5,     0,    62,   173,    23,     4,     4,
    11,     8,     5,   173,    13,     8,     3,     4,   185,    15,
    15,    35,   120,     4,    21,   185,    42,    40,    10,     5,
     5,     4,    49,    47,    91,    92,    52,     9,     4,    40,
    60,     4,    58,     5,     9,    97,     3,     4,     5,    65,
     5,    53,     9,    69,    70,    71,    23,    24,    25,   116,
    76,     4,    16,    53,    50,    61,    41,    42,    43,    44,
    45,    46,     4,    51,    90,     4,    50,     5,    49,     4,
   132,    95,    51,    19,    18,     5,     4,   144,   104,    49,
    54,     8,    22,    52,    11,    12,    20,    14,    15,   115,
    17,     0,     0,   117,    21,    18,   131,   123,   189,    26,
    27,   122,   146,   185,   130,   129,   168,   169,   170,   135,
     3,     4,     5,     6,     7,   170,     9,   188,   138,   143,
    47,    48,   148,    -1,    -1,   187,   188,   153,   154,    -1,
   136,    -1,    -1,   195,   202,    -1,   162,    -1,   164,    -1,
    -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,   210,   175,
   212,   177,    -1,    -1,    -1,    -1,    -1,    -1,   182,   183,
   186,   223,    -1,    -1,   226,    -1,   190,   229,    -1,    -1,
   232,    -1,   202,   235,    -1,    -1,   238,    -1,    -1,   241,
   204,    -1,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   219,   222,    -1,    -1,   225,
    -1,     9,   228,    -1,    -1,   231,    -1,    -1,   234,    -1,
    -1,   237,    -1,    -1,   240,    -1,    -1,    -1,    -1,   243,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 500
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}

// CHJ - removing these because of the alloca causing a link error
//      yystacksize *= 2;
//      if (yystacksize > YYMAXDEPTH)
//	yystacksize = YYMAXDEPTH;
//      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
//      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
//      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
//      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
//#ifdef YYLSP_NEEDED
//      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
//      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
//#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 130 "tdl.y"
{;
    break;}
case 2:
#line 132 "tdl.y"
{initialize_parser ();;
    break;}
case 4:
#line 136 "tdl.y"
{process_validation_keycode (); finalize_parser ();;
    break;}
case 9:
#line 140 "tdl.y"
{initialize_template ();;
    break;}
case 10:
#line 141 "tdl.y"
{finalize_template ();;
    break;}
case 11:
#line 144 "tdl.y"
{process_template_statement();;
    break;}
case 13:
#line 147 "tdl.y"
{strcpy (manufacturer_code, yyvsp[0].str);;
    break;}
case 14:
#line 148 "tdl.y"
{strcpy (id_number_of_bits, yyvsp[0].str);;
    break;}
case 15:
#line 149 "tdl.y"
{strcpy (template_id, yyvsp[0].str);;
    break;}
case 16:
#line 150 "tdl.y"
{description = NULL;;
    break;}
case 17:
#line 150 "tdl.y"
{;
    break;}
case 20:
#line 153 "tdl.y"
{process_abstract_statement();;
    break;}
case 22:
#line 154 "tdl.y"
{process_align ();;
    break;}
case 26:
#line 159 "tdl.y"
{process_property_definition ();;
    break;}
case 28:
#line 161 "tdl.y"
{process_spacing ();;
    break;}
case 30:
#line 164 "tdl.y"
{process_tdl_version_number ();;
    break;}
case 31:
#line 165 "tdl.y"
{process_ugid ();;
    break;}
case 32:
#line 167 "tdl.y"
{abstract = yyvsp[0].str;;
    break;}
case 34:
#line 169 "tdl.y"
{comment = yyvsp[0].str; process_comment();;
    break;}
case 35:
#line 171 "tdl.y"
{enum_name = yyvsp[0].str; 
                      process_enumerate();;
    break;}
case 36:
#line 173 "tdl.y"
{process_end_enumerate();;
    break;}
case 40:
#line 177 "tdl.y"
{variable_name = yyvsp[0].str; 
                      strcpy (numeric, ""); process_enumerate_item ();;
    break;}
case 41:
#line 179 "tdl.y"
{variable_name = yyvsp[0].str; 
                      strcpy (numeric, ""); process_enumerate_item ();;
    break;}
case 42:
#line 181 "tdl.y"
{variable_name = NULL; 
                      strcpy (numeric, yyvsp[0].str); process_enumerate_item ();;
    break;}
case 43:
#line 185 "tdl.y"
{variable_name = yyvsp[-2].str; process_physical_unit ();;
    break;}
case 45:
#line 191 "tdl.y"
{propertyname = yyvsp[0].str;;
    break;}
case 46:
#line 191 "tdl.y"
{;
    break;}
case 47:
#line 193 "tdl.y"
{strcpy(subproperty, ""); register_mask = NULL;;
    break;}
case 48:
#line 195 "tdl.y"
{process_subproperty();;
    break;}
case 50:
#line 196 "tdl.y"
{strcpy(subproperty, "DEFAULT"); ;
    break;}
case 51:
#line 197 "tdl.y"
{strcpy(subproperty, "INITIALIZE");;
    break;}
case 52:
#line 198 "tdl.y"
{strcpy(subproperty, "READWRITE");;
    break;}
case 53:
#line 199 "tdl.y"
{strcpy(subproperty, "CTRLFUNCTIONMASK");;
    break;}
case 54:
#line 200 "tdl.y"
{register_mask = yyvsp[0].str;;
    break;}
case 55:
#line 201 "tdl.y"
{strcpy(subproperty, "FUNCTIONTYPE");;
    break;}
case 56:
#line 202 "tdl.y"
{strcpy(subproperty, "FUNCTION");;
    break;}
case 57:
#line 204 "tdl.y"
{description = NULL; 
                             function_propertyname = NULL;
                             function_register_mask = NULL;
    break;}
case 58:
#line 207 "tdl.y"
{function_propertyname = NULL;
                           function_register_mask = NULL;
    break;}
case 59:
#line 209 "tdl.y"
{description = NULL; function_propertyname = yyvsp[0].str;;
    break;}
case 60:
#line 210 "tdl.y"
{function_register_mask = yyvsp[0].str;;
    break;}
case 62:
#line 212 "tdl.y"
{strcpy(access_level,"");;
    break;}
case 63:
#line 213 "tdl.y"
{strcpy(access_level,"ID");;
    break;}
case 64:
#line 214 "tdl.y"
{strcpy(access_level,"CAL");;
    break;}
case 65:
#line 215 "tdl.y"
{strcpy(access_level, "USR");;
    break;}
case 66:
#line 217 "tdl.y"
{strcpy(datatype, "UNINT");;
    break;}
case 67:
#line 218 "tdl.y"
{strcpy(datatype, "CHR5");;
    break;}
case 68:
#line 219 "tdl.y"
{strcpy(datatype, "DATE");;
    break;}
case 69:
#line 221 "tdl.y"
{strcpy(datatype, "ConRelRes");;
    break;}
case 70:
#line 223 "tdl.y"
{strcpy(datatype, "ConRes");;
    break;}
case 71:
#line 224 "tdl.y"
{strcpy(datatype, "ASCII");;
    break;}
case 72:
#line 225 "tdl.y"
{strcpy(datatype, "String5");;
    break;}
case 73:
#line 226 "tdl.y"
{strcpy(datatype, "String7");;
    break;}
case 74:
#line 227 "tdl.y"
{strcpy(datatype, "String16");;
    break;}
case 75:
#line 228 "tdl.y"
{strcpy(datatype, "Single");;
    break;}
case 76:
#line 229 "tdl.y"
{strcpy(datatype, "Unicode");;
    break;}
case 77:
#line 230 "tdl.y"
{strcpy(datatype, "BitBin");;
    break;}
case 78:
#line 231 "tdl.y"
{enum_name = yyvsp[0].str; 
                     strcpy(datatype, "Enumeration");;
    break;}
case 79:
#line 234 "tdl.y"
{format = NULL;;
    break;}
case 80:
#line 234 "tdl.y"
{format = yyvsp[0].str;;
    break;}
case 81:
#line 236 "tdl.y"
{physical_unit = NULL;;
    break;}
case 82:
#line 237 "tdl.y"
{physical_unit=yyvsp[0].str;;
    break;}
case 83:
#line 238 "tdl.y"
{physical_unit = NULL;
    break;}
case 84:
#line 239 "tdl.y"
{strcpy(dot2_1, yyvsp[0].str);;
    break;}
case 85:
#line 240 "tdl.y"
{strcpy(dot2_2, yyvsp[0].str);;
    break;}
case 86:
#line 241 "tdl.y"
{strcpy(dot2_3, yyvsp[0].str);;
    break;}
case 87:
#line 242 "tdl.y"
{strcpy(dot2_4, yyvsp[0].str);;
    break;}
case 88:
#line 243 "tdl.y"
{strcpy(dot2_5, yyvsp[0].str);;
    break;}
case 89:
#line 244 "tdl.y"
{strcpy(dot2_6, yyvsp[0].str);;
    break;}
case 90:
#line 245 "tdl.y"
{strcpy(dot2_7, yyvsp[0].str);;
    break;}
case 91:
#line 246 "tdl.y"
{strcpy(dot2_8, yyvsp[0].str);;
    break;}
case 92:
#line 247 "tdl.y"
{strcpy(dot2_9, yyvsp[0].str);;
    break;}
case 93:
#line 248 "tdl.y"
{strcpy(dot2_10, yyvsp[0].str);;
    break;}
case 94:
#line 249 "tdl.y"
{strcpy(dot2_11, yyvsp[0].str);;
    break;}
case 95:
#line 250 "tdl.y"
{strcpy(dot2_12, yyvsp[0].str);;
    break;}
case 97:
#line 253 "tdl.y"
{assignment_found = false;;
    break;}
case 98:
#line 254 "tdl.y"
{assignment_found = true; hex_integer=NULL;
                      binary_integer = NULL; variable_name = NULL;
                      assignment_string = NULL; strcpy(numeric, "");;
    break;}
case 100:
#line 258 "tdl.y"
{hex_integer = yyvsp[0].str;;
    break;}
case 101:
#line 259 "tdl.y"
{binary_integer = yyvsp[0].str;;
    break;}
case 102:
#line 260 "tdl.y"
{variable_name = yyvsp[0].str;;
    break;}
case 103:
#line 261 "tdl.y"
{strcpy (numeric,yyvsp[0].str);;
    break;}
case 104:
#line 262 "tdl.y"
{assignment_string = yyvsp[0].str;;
    break;}
case 105:
#line 266 "tdl.y"
{process_selectcase ();;
    break;}
case 106:
#line 268 "tdl.y"
{process_endselect ();;
    break;}
case 109:
#line 271 "tdl.y"
{process_case ();;
    break;}
case 110:
#line 272 "tdl.y"
{process_case_end();;
    break;}
case 112:
#line 274 "tdl.y"
{variable_name = yyvsp[0].str;;
    break;}
case 113:
#line 276 "tdl.y"
{process_structarray_statement ();;
    break;}
case 114:
#line 278 "tdl.y"
{process_endstructarray_statement ();;
    break;}
case 117:
#line 281 "tdl.y"
{process_property_definition ();;
    break;}
case 119:
#line 285 "tdl.y"
{strcpy (tdl_version_number, yyvsp[0].str);;
    break;}
case 120:
#line 286 "tdl.y"
{ugid=yyvsp[0].str;;
    break;}
case 122:
#line 290 "tdl.y"
{strcpy (validation_keycode, yyvsp[0].str);;
    break;}
case 123:
#line 292 "tdl.y"
{description=yyvsp[0].str;;
    break;}
case 124:
#line 294 "tdl.y"
{strcpy (case_bit_value, yyvsp[0].str);;
    break;}
case 125:
#line 296 "tdl.y"
{strcpy (selectcase_number_of_bits, yyvsp[0].str);;
    break;}
case 126:
#line 297 "tdl.y"
{strcpy (size,yyvsp[0].str);;
    break;}
case 127:
#line 298 "tdl.y"
{strcpy (boundary,yyvsp[0].str);;
    break;}
case 128:
#line 300 "tdl.y"
{strcpy (startvalue,yyvsp[0].str);;
    break;}
case 129:
#line 301 "tdl.y"
{strcpy (tolerance,yyvsp[0].str);;
    break;}
case 136:
#line 310 "tdl.y"
{statement_count++; print_statement_num();;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 313 "tdl.y"

