///////////////////////////////////////////////////////
// tdlparser.h - IEEE 1451.4 TDL grammar header file
//
// 27 January 2003
// Updated 10 September 2003
//
// This file declares common variables and other header
// files used by the Template Description Language (TDL)
// parser routines.  It is intended to be used in conjunction
// with tdl.l, tdl.y, tdlmain.cpp, and tdlparser.cpp.
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <afx.h> 
#include <afxcoll.h> 
#include <string.h> // Use standard C strings for general compatability.

// Define this to avoid having to do dynamic allocation.

#define MAX_STRING 100
#define MAX_TEMPLATES 1000
#define MAX_STRUCTS 10
#define MAX_SELECTS 10
#define MAX_CASES 50

// Token string values returned to parser routines from bison (yacc).

extern char* abstract;
extern char* assignment_string;
extern char* binary_integer;
extern char* comment;
extern char* description;
extern char* ugid;
extern char* format;
extern char* hex_integer;
extern char* physical_unit;
extern char* propertyname;
extern char* variable_name;
extern char* enum_name;
extern char* register_mask;
extern char* function_propertyname;  // Used with subproperty function.
extern char* function_register_mask; // Used with subproperty function.

// The token numeric values returned by bison can not be just by pointer.
// They must be copied into a string or else they may be overwritten
// before we get to the end of the statement.
// This is not true for the string values above.

extern char value[MAX_STRING];
extern char startvalue[MAX_STRING];
extern char tolerance[MAX_STRING];
extern char boundary[MAX_STRING];
extern char numeric[MAX_STRING];
extern char size[MAX_STRING];
extern char case_bit_value[MAX_STRING];
extern char selectcase_number_of_bits[MAX_STRING];
extern char tdl_version_number[MAX_STRING];
extern char validation_keycode[MAX_STRING];
extern char access_level[MAX_STRING];
extern char datatype[MAX_STRING];
extern char subproperty[MAX_STRING];
extern char manufacturer_code [MAX_STRING];
extern char id_number_of_bits [MAX_STRING];
extern char template_id [MAX_STRING];

extern char dot2_1[MAX_STRING];
extern char dot2_2[MAX_STRING];
extern char dot2_3[MAX_STRING];
extern char dot2_4[MAX_STRING];
extern char dot2_5[MAX_STRING];
extern char dot2_6[MAX_STRING];
extern char dot2_7[MAX_STRING];
extern char dot2_8[MAX_STRING];
extern char dot2_9[MAX_STRING];
extern char dot2_10[MAX_STRING];
extern char dot2_11[MAX_STRING];
extern char dot2_12[MAX_STRING];

// Globals not tokens

extern bool assignment_found;
extern FILE *tokens;
extern FILE *messages;

// debug variables

extern int statement_count;
